#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include "array.h"

array3 new_array3(int dim1, int dim2, int dim3)
{
  int i,j;
  array3 a;
  
  a=(SCALAR ***)malloc(dim1*sizeof(SCALAR));
  if(a==NULL)error("No Memory Space\n");
  for(i=0;i<dim1;++i){
    a[i]=(SCALAR **)malloc((dim2+1)*sizeof(SCALAR));
    if(a[i]==NULL)error("No Memory Space\n");
    for(j=0;j<dim2;++j){
      a[i][j]=(SCALAR *)malloc(dim3*sizeof(SCALAR));
      if(a[i][j]==NULL)error("No Memory Space\n");
    }
    a[i][dim2]=NULL;
  }
  return a;
}

array4 new_array4(int dim1, int dim2, int dim3, int dim4)
{
  int i,j,k;
  array4 a;
  
  a=(SCALAR ****)malloc(dim1*sizeof(SCALAR));
  if(a==NULL)error("No Memory Space\n");
  for(i=0;i<dim1;++i){
    a[i]=(SCALAR ***)malloc(dim2*sizeof(SCALAR));
    if(a[i]==NULL)error("No Memory Space\n");
    for(j=0;j<dim2;++j){
      a[i][j]=(SCALAR **)malloc((dim3+1)*sizeof(SCALAR));
      if(a[i][j]==NULL)error("No Memory Space\n");
      for(k=0;k<dim3;++k){
	a[i][j][k]=(SCALAR *)malloc(dim4*sizeof(SCALAR));
	if(a[i][j][k]==NULL)error("No Memory Space\n");
      }
      a[i][j][dim3]=NULL;
    }
  }
  return a;
}

void free_array3(array3 a, int dim)
{
  int i;
  matrix b;
  
  for(i=0;i<dim;++i){
    b=a[i];
    while(*b!=NULL)free(*b++);
    free(a[i]);
  }
  free(a);
}

void free_array4(array4 a, int dim1, int dim2)
{
  int i,j;
  matrix b;

  for(i=0;i<dim1;++i){
    for(j=0;j<dim2;++j){
      b=a[i][j];
      while(*b!=NULL)free(*b++);
      free(a[i][j]);
    }
    free(a[i]);
  }
  free(a);
}

